﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace NTL.KinectLib
{
    //*************************************************************************
    //*************************************************************************
    //【CLASS】『LowPassFilter』【ローパスフィルタ】
    //*************************************************************************
    //*************************************************************************
    public class LowPassFilter
    {
        private int nFIFO;
        private int ptr = 0;
        private double[] FIFO;
        private double sum;
        private double K;

        //***************************************************************
        //【Initialize】
        //***************************************************************
        public void Initialize(int n)
        {
            K = 1.0f / (double)n;
            sum = 0;
            nFIFO = n;
            FIFO = new double[n];
            for (var i = 0; i < n; i++) { FIFO[i] = 0.0; }
        }

        //***************************************************************
        //【LPF】
        //***************************************************************
        public double LPF(double DataIn)
        {
            sum = sum + DataIn - FIFO[ptr];
            FIFO[ptr] = DataIn;
            ptr++;
            if (ptr == nFIFO) ptr = 0;
            return (sum * K);
        }
    }
}
